class
	P_CMPABS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_cmpabs (a_u, a_v: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_dsize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_cmp: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_u.item.mp_size >= 0 then
				l_usize := (a_u.item.mp_size).to_integer_32
			else
				l_usize := (-a_u.item.mp_size).to_integer_32
			end
			if a_v.item.mp_size >= 0 then
				l_vsize := (a_v.item.mp_size).to_integer_32
			else
				l_vsize := (-a_v.item.mp_size).to_integer_32
			end
			l_dsize := l_usize - l_vsize
			if l_dsize /= 0 then
				Result := l_dsize.to_integer_32
				l_return := True
			end
			if not l_return then
				l_up := a_u.item.mp_d
				l_vp := a_v.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cmp := 0
					l_gmp_i := l_usize
					from
					until
						(l_break)
					loop
						l_break := False
						l_gmp_i := l_gmp_i - 1
						if not (l_gmp_i >= 0) then
							l_break := True
						end
						if not (l_break) then
							l_gmp_x := l_up[l_gmp_i]
							l_gmp_y := l_vp[l_gmp_i]
							if l_gmp_x /= l_gmp_y then
								if l_gmp_x > l_gmp_y then
									l_cmp := 1
								else
									l_cmp := -1
								end
								l_break := True
							end
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Result := l_cmp
			end
		end

end
