class
	P_DIVIS_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_divisible_p (a_a, a_d: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_dsize: INTEGER_32
			l_asize: INTEGER_32
			l_tmp_0: INTEGER_32
			l_tmp_1: INTEGER_32
			l_return: BOOLEAN
		do
			l_dsize := (a_d.item.mp_size).to_integer_32
			l_asize := (a_a.item.mp_size).to_integer_32
			if (builtin_expect ((l_dsize = 0).to_integer, 0)).to_boolean then
				Result := (l_asize = 0).to_integer
				l_return := True
			end
			if not l_return then
				if l_dsize >= 0 then
					l_tmp_0 := l_dsize
				else
					l_tmp_0 := -l_dsize
				end
				if l_asize >= 0 then
					l_tmp_1 := l_asize
				else
					l_tmp_1 := -l_asize
				end
				Result := ((create {P_GMP_IMPL_STATIC}).gmpn_divisible_p (a_a.item.mp_d, l_tmp_1, a_d.item.mp_d, l_tmp_0))
			end
		end

end
