class
	P_GET_STR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_get_str (a_res_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32; a_x: CE_POINTER [PD_MPZ_STRUCT]): CE_POINTER [INTEGER_8]
		local
			l_res_str: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_x_size: INTEGER_32
			l_str: CE_POINTER [INTEGER_8]
			l_return_str: CE_POINTER [INTEGER_8]
			l_str_size: NATURAL_32
			l_alloc_size: NATURAL_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_lb_base: INTEGER_32
			l_cnt: INTEGER_32
			l_totbits: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp_0: INTEGER_32
			l_tmp_1: INTEGER_32
			l_tmp_3: CE_POINTER [INTEGER_8]
			l_tmp_7: CE_POINTER [ANY]
			l_actual_size: NATURAL_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_res_str := a_res_str
			l_base := a_base
			l_x_size := (a_x.item.mp_size).to_integer_32
			l_alloc_size := (0).to_natural_32
			if l_base >= 0 then
				l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
				if l_base = 0 then
					l_base := 10
				elseif l_base > 36 then
					l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
					if l_base > 62 then
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
				end
			else
				l_base := -l_base
				l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
			end
			if not l_return then
				if l_res_str.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_x_size >= 0 then
							l_tmp_1 := l_x_size
						else
							l_tmp_1 := -l_x_size
						end
						if l_tmp_1 = 0 then
							l_alloc_size := (1).to_natural_32
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_x_size >= 0 then
									l_tmp := l_x_size
								else
									l_tmp := -l_x_size
								end
								l_cnt := builtin_clzl (a_x.item.mp_d[(l_tmp - 1)])
								l_break := True
							end
							l_break := False
							if l_x_size >= 0 then
								l_tmp_0 := l_x_size
							else
								l_tmp_0 := -l_x_size
							end
							l_totbits := l_tmp_0.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
							if ((l_base).bit_and ((l_base - 1))) = 0 then
								l_lb_base := ((create {P_GMP_IMPL_STATIC}).gmpn_bases[l_base].big_base).to_integer_32
								l_alloc_size := ((l_totbits + l_lb_base.to_natural_32) - {NATURAL_32} 1) // l_lb_base.to_natural_32
							else
								l_alloc_size := (l_totbits.to_real_64 * (create {P_GMP_IMPL_STATIC}).gmpn_bases[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
							end
						end
						l_break := True
					end
					l_break := False
					l_alloc_size := l_alloc_size + (1 + (l_x_size < 0).to_integer).to_natural_32
					l_res_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([l_alloc_size]))))
				end
				l_return_str := l_res_str
				if l_x_size < 0 then
					l_tmp_3 := l_res_str
					l_res_str := l_res_str + 1
					l_tmp_3[0] := (('-').code).to_integer_8
					l_x_size := -l_x_size
				end
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_xp := a_x.item.mp_d
				if ((l_base).bit_and ((l_base - 1))) /= 0 then
					if (builtin_expect (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_7 := (l_aaf.new (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_7 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_7)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_xp, a_x.item.mp_d, l_x_size)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				l_str_size := (create {P_GMP_STATIC}).gmpn_get_str (create {CE_NATURAL_8_POINTER}.make_cast (l_res_str), l_base, l_xp, l_x_size)
				l_str := l_res_str
				if (l_res_str[0]).to_integer_32 = 0 then
					if l_str_size /= {NATURAL_32} 1 then
						l_str_size := l_str_size - 1
						l_str := l_str + 1
					end
				end
				l_i := 0
				from
				until
					not (l_i.to_natural_32 < l_str_size)
				loop
					l_res_str[l_i] := l_num_to_text[(l_str[l_i]).to_integer_32]
					l_i := l_i + 1
				end
				l_res_str[l_str_size.to_integer_32] := (0).to_integer_8
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				if l_alloc_size /= {NATURAL_32} 0 then
					l_actual_size := (l_str_size + {NATURAL_32} 1) + (l_res_str.distance (l_return_str)).to_natural_32
					from
					until
						(l_break)
					loop
						l_break := False
						if l_alloc_size /= l_actual_size then
							l_return_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_reallocate_func.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_return_str), l_alloc_size * {PLATFORM}.Integer_8_bytes.to_natural_32, l_actual_size * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
						end
						l_break := True
					end
					l_break := False
				end
				Result := l_return_str
			end
		end

end
