class
	P_SCAN0_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_scan0 (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_starting_bit: NATURAL_32): NATURAL_32
		local
			l_u_ptr: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_u_end: CE_POINTER [NATURAL_32]
			l_starting_limb: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_cnt: INTEGER_32
			l_tmp_0: NATURAL_32
			l_q: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u_ptr := a_u.item.mp_d
					l_size := (a_u.item.mp_size).to_integer_32
					if l_size >= 0 then
						l_tmp := l_size
					else
						l_tmp := -l_size
					end
					l_abs_size := l_tmp
					l_u_end := l_u_ptr + l_abs_size
					l_starting_limb := (a_starting_bit // {NATURAL_32} 32).to_integer_32
					l_p := l_u_ptr + l_starting_limb
					if l_starting_limb >= l_abs_size then
						if l_size >= 0 then
							l_tmp_0 := a_starting_bit
						else
							l_tmp_0 := ((0).to_natural_32).bit_not
						end
						Result := l_tmp_0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_limb := l_p.item
						if not (l_size >= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_limb := (l_limb).bit_or (((({NATURAL_32} 1).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						from
						until
							not (not (l_return) and then (l_limb = {NATURAL_32} 4_294_967_295))
						loop
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (l_abs_size.to_natural_32 * {NATURAL_32} 32)
								l_return := True
							end
							if not l_return then
								l_limb := l_p.item
							end
						end
						if not l_return then
							l_limb := (l_limb).bit_not
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 4 then -- else:
						l_q := l_p
				when 5 then -- loop condition:
						if l_q.is_equal (l_u_ptr) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						l_q := l_q - 1
						if l_q.item /= {NATURAL_32} 0 then
							l_pos := -1 + 9 -- goto inverted
						end
				when 7 then
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						l_limb := l_limb - 1
				when 9 then -- inverted:
						l_limb := (l_limb).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)))
						if l_limb = {NATURAL_32} 0 then
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (((0).to_natural_32).bit_not)
								l_return := True
							end
							if not l_return then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_limb := l_p.item
									if l_limb /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_p := l_p + 1
									end
								end
								l_break := False
							end
						end
				when 10 then -- if done | if done
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_limb)
							l_break := True
						end
						l_break := False
						Result := ((l_p.distance (l_u_ptr)).to_natural_32 * {NATURAL_32} 32 + l_cnt.to_natural_32)
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
