class
	P_UI_SUB_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_ui_sub (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_uval: NATURAL_32; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_vn: INTEGER_32
			l_wn: INTEGER_32
			l_cy: NATURAL_32
		do
			l_vp := a_v.item.mp_d
			l_vn := (a_v.item.mp_size).to_integer_32
			l_wp := a_w.item.mp_d
			if l_vn > 1 then
				if (builtin_expect ((l_vn > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_vn)))
				else
					l_wp := a_w.item.mp_d
				end
				l_vp := a_v.item.mp_d;
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_vp, l_vn, a_uval).do_nothing
				l_wn := -(l_vn - (l_wp[(l_vn - 1)] = {NATURAL_32} 0).to_integer)
			elseif l_vn = 1 then
				if a_uval >= l_vp[0] then
					l_wp[0] := a_uval - l_vp[0]
					l_wn := (l_wp[0] /= {NATURAL_32} 0).to_integer
				else
					l_wp[0] := l_vp[0] - a_uval
					l_wn := (-1).to_integer_32
				end
			elseif l_vn = 0 then
				l_wp[0] := a_uval
				l_wn := (a_uval /= {NATURAL_32} 0).to_integer
			else
				l_vn := -l_vn
				if (builtin_expect ((l_vn + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_vn + 1)))
				else
					l_wp := a_w.item.mp_d
				end
				l_vp := a_v.item.mp_d
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_wp, l_vp, l_vn, a_uval)
				l_wp[l_vn] := l_cy
				l_wn := l_vn + (l_cy /= {NATURAL_32} 0).to_integer
			end
			a_w.item.mp_size := l_wn.to_integer_32
		end

end
