class
	P_LCM_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_lcm_ui (a_r, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: NATURAL_32)
		local
			l_v: NATURAL_32
			l_usize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_g: NATURAL_32
			l_c: NATURAL_32
			l_return: BOOLEAN
		do
			l_v := a_v
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize = 0 then
				a_r.item.mp_size := 0
				l_return := True
			elseif l_v = {NATURAL_32} 0 then
				a_r.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if (builtin_expect ((l_usize + 1 > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_r, l_usize + 1).do_nothing
				end
				l_up := a_u.item.mp_d
				l_g := ((create {P_GMP_STATIC}).gmpn_gcd_1 (l_up, l_usize, l_v))
				l_v := l_v // l_g
				l_rp := a_r.item.mp_d
				l_c := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_up, l_usize, l_v)
				l_rp[l_usize] := l_c
				l_usize := l_usize + (l_c /= {NATURAL_32} 0).to_integer
				a_r.item.mp_size := l_usize.to_integer_32
			end
		end

end
