class
	P_OUT_STR_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_out_str (a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32; a_x: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_base: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_x_size: INTEGER_32
			l_str: CE_POINTER [NATURAL_8]
			l_str_size: NATURAL_32
			l_i: NATURAL_32
			l_written: NATURAL_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_0: INTEGER_32
			l_tmp_5: CE_POINTER [ANY]
			l_tmp_10: CE_POINTER [ANY]
			l_fwret: NATURAL_32
			l_tmp_14: NATURAL_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_stream := a_stream
			l_base := a_base
			l_x_size := (a_x.item.mp_size).to_integer_32
			if l_stream.is_void then
				l_stream := ce_output_file_pointer
			end
			if l_base >= 0 then
				l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
				if l_base = 0 then
					l_base := 10
				elseif l_base > 36 then
					l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
					if l_base > 62 then
						Result := (0).to_natural_32
						l_return := True
					end
				end
			else
				l_base := -l_base
				l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
			end
			if not l_return and then (l_x_size = 0) then
				fputc (('0').code, l_stream).do_nothing
				if (ferror (l_stream)).to_boolean then
					l_tmp_0 := 0
				else
					l_tmp_0 := 1
				end
				Result := l_tmp_0.to_natural_32
				l_return := True
			end
			if not l_return then
				l_written := (0).to_natural_32
				if l_x_size < 0 then
					fputc (('-').code, l_stream).do_nothing
					l_x_size := -l_x_size
					l_written := (1).to_natural_32
				end
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_str_size := ((l_x_size * 32).to_double * (create {P_GMP_IMPL_STATIC}).gmpn_bases[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 3
				if (builtin_expect ((l_str_size < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_5 := (l_aaf.new (l_str_size))
				else
					l_tmp_5 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, l_str_size))
				end
				l_str := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp_5)
				if (builtin_expect (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_10 := (l_aaf.new (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_10 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_10)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_xp, a_x.item.mp_d, l_x_size)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_str_size := (create {P_GMP_STATIC}).gmpn_get_str (l_str, l_base, l_xp, l_x_size)
				from
				until
					(l_str.item).to_integer_32 /= 0
				loop
					l_str_size := l_str_size - 1
					l_str := l_str + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_str_size)
				loop
					l_str[l_i.to_integer_32] := (l_num_to_text[(l_str[l_i.to_integer_32]).to_integer_32]).to_natural_8
					l_i := l_i + 1
				end
				l_str[l_str_size.to_integer_32] := (0).to_natural_8
				l_fwret := fwrite (create {CE_VOID_POINTER}.make_cast (l_str), (1).to_natural_32, l_str_size, l_stream)
				l_written := l_written + l_fwret
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				if (ferror (l_stream)).to_boolean then
					l_tmp_14 := (0).to_natural_32
				else
					l_tmp_14 := l_written
				end
				Result := l_tmp_14
			end
		end

end
