class
	P_SET_STR_STATIC

inherit
	CE_UTILITIES
	S_CTYPE_STATIC
	S_STRING_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_set_str (a_x: CE_POINTER [PD_MPZ_STRUCT]; a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		local
			l_str: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_str_size: NATURAL_32
			l_s: CE_POINTER [INTEGER_8]
			l_begs: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_xsize: INTEGER_32
			l_c: INTEGER_32
			l_negative: INTEGER_32
			l_digit_value: CE_POINTER [NATURAL_8]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp_1: CE_POINTER [INTEGER_8]
			l_tmp_2: INTEGER_32
			l_tmp_3: CE_POINTER [INTEGER_8]
			l_tmp_4: CE_POINTER [INTEGER_8]
			l_tmp_5: CE_POINTER [INTEGER_8]
			l_tmp_6: CE_POINTER [INTEGER_8]
			l_tmp_11: CE_POINTER [ANY]
			l_dig: INTEGER_32
			l_tmp_14: CE_POINTER [INTEGER_8]
			l_tmp_16: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_str := a_str
			l_base := a_base
			l_digit_value := (create {P_INP_STR_STATIC}).gmp_digit_value_tab
			if l_base > 36 then
				l_digit_value := l_digit_value + (224)
				if l_base > 62 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp := l_str
					l_str := l_str + 1
					l_c := ((l_tmp[0]).to_natural_8).to_integer_32
					if not isspace (l_c).to_boolean then
						l_break := True
					end
				end
				l_break := False
				l_negative := 0
				if l_c = 45 then
					l_negative := 1
					l_tmp_1 := l_str
					l_str := l_str + 1
					l_c := ((l_tmp_1[0]).to_natural_8).to_integer_32
				end
				if l_base = 0 then
					l_tmp_2 := 10
				else
					l_tmp_2 := l_base
				end
				if (l_digit_value[l_c]).to_integer_32 >= l_tmp_2 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				if l_base = 0 then
					l_base := 10
					if l_c = 48 then
						l_base := 8
						l_tmp_3 := l_str
						l_str := l_str + 1
						l_c := ((l_tmp_3[0]).to_natural_8).to_integer_32
						if l_c = 120 then
							l_base := 16
							l_tmp_4 := l_str
							l_str := l_str + 1
							l_c := ((l_tmp_4[0]).to_natural_8).to_integer_32
						elseif l_c = 88 then
							l_base := 16
							l_tmp_4 := l_str
							l_str := l_str + 1
							l_c := ((l_tmp_4[0]).to_natural_8).to_integer_32
						elseif l_c = 98 then
							l_base := 2
							l_tmp_5 := l_str
							l_str := l_str + 1
							l_c := ((l_tmp_5[0]).to_natural_8).to_integer_32
						elseif l_c = 66 then
							l_base := 2
							l_tmp_5 := l_str
							l_str := l_str + 1
							l_c := ((l_tmp_5[0]).to_natural_8).to_integer_32
						end
					end
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if l_c /= 48 then
						if not isspace (l_c).to_boolean then
							l_break := True
						end
					end
					if not (l_break) then
						l_tmp_6 := l_str
						l_str := l_str + 1
						l_c := ((l_tmp_6[0]).to_natural_8).to_integer_32
					end
				end
				l_break := False
				if l_c = 0 then
					a_x.item.mp_size := 0
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_str_size := strlen (l_str - 1)
				if (builtin_expect ((l_str_size + {NATURAL_32} 1 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_11 := (l_aaf.new (l_str_size + {NATURAL_32} 1))
				else
					l_tmp_11 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, l_str_size + {NATURAL_32} 1))
				end
				l_begs := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_11)
				l_s := l_begs
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_str_size))
				loop
					if not isspace (l_c).to_boolean then
						l_dig := (l_digit_value[l_c]).to_integer_32
						if l_dig >= l_base then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							Result := (-1)
							l_return := True
						end
						if not l_return then
							l_tmp_14 := l_s
							l_s := l_s + 1
							l_tmp_14[0] := l_dig.to_integer_8
						end
					end
					if not l_return then
						l_tmp_16 := l_str
						l_str := l_str + 1
						l_c := ((l_tmp_16[0]).to_natural_8).to_integer_32
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				l_str_size := (l_s.distance (l_begs)).to_natural_32
				l_xsize := 2 + (l_str_size.to_real_64 / ((32).to_double * (create {P_GMP_IMPL_STATIC}).gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer
				if (builtin_expect ((l_xsize > (a_x.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_x, l_xsize).do_nothing
				end
				l_xsize := (create {P_GMP_STATIC}).gmpn_set_str (a_x.item.mp_d, create {CE_NATURAL_8_POINTER}.make_cast (l_begs), l_str_size, l_base)
				if l_negative.to_boolean then
					a_x.item.mp_size := (-l_xsize).to_integer_32
				else
					a_x.item.mp_size := l_xsize.to_integer_32
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				Result := 0
			end
		end

end
