class
	S_GCC_BUILTIN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	builtin_expect (a_arg1: INTEGER_32; a_arg2: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __builtin_expect($a_arg1, $a_arg2);"
		end

	builtin_clzl (a_arg1: NATURAL_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __builtin_clzl($a_arg1);"
		end

	builtin_ctzl (a_arg1: NATURAL_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __builtin_ctzl($a_arg1);"
		end

end
